# -*- coding: utf-8 -*-
import globalPluginHandler
import ui
import api
class GlobalPlugin(globalPluginHandler.GlobalPlugin):
	def __init__(self, *args, **kwargs):
		globalPluginHandler.GlobalPlugin.__init__(self, *args, **kwargs)
	def script_split_text(self, gesture):
		try:
			data=api.getClipData()
		except TypeError:
			data=''
		if not data:
			ui.message(u'Буфер обмена не содержит текст.')
			return
		split_type=0 if gesture._get_identifiers()[0].split('+')[1]=='NVDA' else 1
		if split_type==0:
			splitter='.'
		else:
			splitter=' '
		lines=data.replace('\r', '').split('\n')
		before=len(lines)
		result=[]
		for line in lines:
			try:
				result.append(self.process_line(line, splitter))
			except ValueError:
				return
		result='\r\n'.join(result)
		after=result.count('\n')+1
		ui.message(u'До разбивки %d строк, после разбивки %d строк.'%(before, after))
		api.copyToClip(result)
	def process_line(self, line, splitter):
		result=['']
		for chunk in line.split(splitter):
			if not chunk:
				continue
			if len(chunk)>255:
				ui.message(u'Один из непрерывных отрезков более 255 символов. Разбивка невозможна.')
				raise ValueError
			if len(result[-1])+len(chunk)>255:
				result.append('')
			result[-1]+=chunk+splitter
		return '\r\n'.join(result)
	__gestures={'kb:nvda+alt+s': 'split_text', 'kb:nvda+alt+control+s': 'split_text'}
